/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Mozilla Public 
 * License version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Initial Developer of the Original Code is R.V.Guha. Portions
 * created by R.V.Guha are copyright (c) 2000 R.V.Guha. All Rights
 * Reserved.
 */

#include <stdio.h>
typedef struct _DB_CursorStruct* DB_Cursor;


int DB_CreateDatabase (const char* db);
int DB_CloseDatabase (const char* db);


int DB_AddForwardIndex(const char* db, const char* forwardIndex, const char* value, int dupcheck);
int DB_RemoveForwardIndex(const char* db, const char* reverseIndex, const char* value);

int DB_AddReverseIndex(const char* db, const char* forwardIndex, const char* value, int dupCheck);
int DB_RemoveReverseIndex(const char* db, const char* reverseIndex, const char* value);

int DB_GetForwardCursor(const char* db, const char* forwardIndex, DB_Cursor *c);
int DB_GetReverseCursor(const char* db, const char* forwardIndex, DB_Cursor *c);
int DB_CursorAdvance(DB_Cursor c);
int  DB_CursorCurrentValue (DB_Cursor c, void** value) ;
int  DB_CursorCurrentValueType (DB_Cursor c, int *type) ;
int  DB_CursorCurrentValueSize (DB_Cursor c, int *sz) ;


int DB_GetArcsInCursor(const char* dbn, const char* index, DB_Cursor *dbc);
int DB_GetArcsOutCursor(const char* dbn, const char* index, DB_Cursor *dbc);
int DB_GetFileCode(const char* db, const char* url, char **code, FILE **file);
int DB_Flush (const char* db) ;

int DB_ReleaseCursor(DB_Cursor c);
void   DB_Initialize();

