/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Mozilla Public 
 * License version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Initial Developer of the Original Code is R.V.Guha. Portions
 * created by R.V.Guha are copyright (c) 2000 R.V.Guha. All Rights
 * Reserved.
 */


#include "rdf.h"
#include "dbglue.h"
#include <pthread.h>


typedef struct _IndexStruct* Index;


typedef struct _RDF_CursorStruct {
  RDF_DB       db;
  RDF_Resource res;
  RDF_Resource arc;
  void*        value;
  RDF_ValueType type;
  DB_Cursor    dbCursor;
  int          inversep;
  struct _RDF_CursorStruct* next;
  Index index;
} RDF_CursorStruct;





#define resourceEquals(x, y) (strcmp((char*)x, (char*)y) == 0)

#define freeResource(x) freeMem(x)
